import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as S, useState as y, useMemo as j, useEffect as ee } from "react";
import { isMobile as z } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { Table as se, Skeleton as ne } from "antd";
import ie from "../../BitzDrawer/index.mjs";
import le from "../../BitzLoadMore/index.mjs";
import re from "../../BitzPagination/index.mjs";
import oe from "../../BitzNoData/index.mjs";
import te, { TableContext as xe } from "../Store/index.mjs";
import he from "../TableSkeleton/index.mjs";
import { columnSort as fe, genColumnKey as L } from "../Store/utils/index.mjs";
import "./index.less.mjs";
import be from "../../../node_modules/lodash-es/at.mjs";
const je = ({
  tableItemEmit: m = () => {
  },
  showPagination: T = !0,
  dataSource: s = [],
  total: a = 0,
  columns: x,
  loading: f = !1,
  skeletonNum: C = 2,
  skeletonRender: N,
  skeletonRowNum: M = 4,
  skeletonRowsWidth: k = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: E = () => {
  },
  mobileLoadEmit: K = () => {
  },
  mobileRefreshEmit: D = () => {
  },
  operations: F = [],
  enableControlPage: O,
  pagination: P,
  paginationEmit: $ = () => {
  },
  mobilePageHeight: _ = 500,
  mobileCancelText: A = "取消",
  noDataTitle: H,
  noDataImg: V,
  color: W,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: d,
  showTableTool: q = !0,
  tableAction: G,
  tableToolbar: J,
  scroll: r,
  resetPage: Q,
  ...h
}) => {
  const t = S(xe), [R, v] = y(!1), [U, X] = y({}), Y = j(() => (s == null ? void 0 : s.length) == a && (s == null ? void 0 : s.length) > 0, [s, a]), Z = (n) => {
    v(!0), X(n), m(n);
  }, g = () => {
    v(!1);
  }, I = (n) => {
    v(!1), E(n.type, U);
  }, b = j(() => {
    const n = (o) => o.map((l) => {
      const u = L(
        (l == null ? void 0 : l.key) || (l == null ? void 0 : l.dataIndex),
        l.index
      ), B = t.columnList[u];
      return B && B.show === !1 ? !1 : l.children ? {
        ...l,
        children: n(l.children)
      } : l;
    }).filter(Boolean);
    return n(x).sort(fe(t.columnList));
  }, [t.columnList, x]), c = j(() => {
    if (h != null && h.rowSelection)
      return {
        ...h.rowSelection,
        fixed: "left",
        columnWidth: 52
      };
  }, [h.rowSelection]);
  ee(() => {
    if (x && x.length > 0) {
      const n = x.map(
        (i) => (
          // @ts-ignore
          L((i == null ? void 0 : i.key) ?? (i == null ? void 0 : i.dataIndex), i == null ? void 0 : i.dataIndex)
        )
      );
      t.setSortKeyColumns(n);
    }
  }, [x]);
  const p = j(() => r != null && r.x ? r : r != null && r.y ? s != null && s.length ? { x: 1e3, y: r.y } : { y: r.y } : s != null && s.length ? { x: 1e3 } : void 0, [s, r]), w = j(() => `${d ?? (t == null ? void 0 : t.tableSize) ?? "lg"}BitzTable`, [d, t.tableSize]);
  return /* @__PURE__ */ e.jsxs("div", { className: "bitzTableBlock", children: [
    !z && /* @__PURE__ */ e.jsxs("div", { className: `bitzTableContainer ${w}`, children: [
      q && /* @__PURE__ */ e.jsxs("div", { className: "bitzTableToolbarBlock", children: [
        G,
        J
      ] }),
      f ? /* @__PURE__ */ e.jsx(
        he,
        {
          columns: b,
          dataLength: s == null ? void 0 : s.length,
          scroll: p,
          rowSelection: c,
          className: w
        }
      ) : /* @__PURE__ */ e.jsx(
        se,
        {
          columns: b,
          dataSource: s,
          loading: f,
          size: "large",
          pagination: !1,
          rowSelection: c,
          scroll: p,
          ...h
        }
      ),
      T && (s == null ? void 0 : s.length) != 0 && /* @__PURE__ */ e.jsx("div", { className: "bitzTablePagination", children: /* @__PURE__ */ e.jsx(
        re,
        {
          enableControl: O,
          pagination: P,
          total: a,
          dataSource: s,
          resetPage: Q,
          paginationEmit: $
        }
      ) })
    ] }),
    z && /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
      (f || (s == null ? void 0 : s.length) > 0) && /* @__PURE__ */ e.jsx(
        le,
        {
          color: W,
          height: _,
          showNoMore: Y,
          refreshEmit: D,
          loadEmit: K,
          extra: /* @__PURE__ */ e.jsxs("div", { className: "mobileTable", children: [
            s == null ? void 0 : s.map((n, i) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: b == null ? void 0 : b.map((o, l) => /* @__PURE__ */ e.jsx("div", { children: !(o != null && o.mobileHide) && /* @__PURE__ */ e.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    Z(n);
                  },
                  children: [
                    /* @__PURE__ */ e.jsxs("div", { className: "label", children: [
                      o.title,
                      "："
                    ] }),
                    /* @__PURE__ */ e.jsx("div", { className: "value", children: o.render(
                      be(n, o == null ? void 0 : o.dataIndex),
                      n,
                      i
                    ) })
                  ]
                }
              ) }, l)) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, i)),
            f && Array.from({ length: C }).map((n, i) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: N ? N() : /* @__PURE__ */ e.jsx(
                ne,
                {
                  title: !1,
                  paragraph: {
                    rows: M,
                    width: k
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, i)),
            /* @__PURE__ */ e.jsx(
              ie,
              {
                className: "tableMobileDrawer",
                open: R,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: g,
                children: /* @__PURE__ */ e.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ e.jsx("div", { className: "boxBody", children: F.map((n, i) => /* @__PURE__ */ e.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        I(n);
                      },
                      children: n.label
                    },
                    i
                  )) }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxFooter", onClick: g, children: A })
                ] })
              }
            )
          ] })
        }
      ),
      !f && /* @__PURE__ */ e.jsx(oe, { data: s, title: H, img: V })
    ] })
  ] });
}, Te = (m) => (
  // @ts-ignore
  /* @__PURE__ */ e.jsx(te, { initValue: m, children: /* @__PURE__ */ e.jsx(je, { ...m }) })
);
export {
  Te as default
};
