import { j as e } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as H, useModal as J, antdModalV5 as P } from "@ebay/nice-modal-react";
import { Modal as Q, Checkbox as U } from "antd";
import t from "./index.module.less.mjs";
import { useState as X, useContext as Y, useCallback as K, useMemo as j } from "react";
import { TableContext as Z } from "../../Store/index.mjs";
import { genColumnKey as A, columnSort as _ } from "../../Store/utils/index.mjs";
import B from "../../../../node_modules/classnames/index.mjs";
import { DndContext as $, DragOverlay as ee, defaultDropAnimationSideEffects as se } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as le, verticalListSortingStrategy as oe, arrayMove as te } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import ne from "./DndItem.mjs";
import { restrictToVerticalAxis as ae, restrictToWindowEdges as ce } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import O from "../../../BitzButton/index.mjs";
import "./index.less.mjs";
import T from "../../../../node_modules/lodash-es/omit.mjs";
import ie from "../../../../node_modules/@ant-design/icons/es/icons/CheckCircleOutlined.mjs";
import re from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
import de from "../../../../node_modules/@ant-design/icons/es/icons/DragOutlined.mjs";
const me = {
  sideEffects: se({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, Ee = H(() => {
  var w;
  const v = J(), C = P(v), [x, b] = X(null), {
    columnList: R,
    setColumnList: V,
    columnsMap: i,
    setColumnsMap: p,
    sortKeyColumns: u,
    setSortKeyColumns: z,
    clearPersistenceStorage: y,
    ...o
  } = Y(Z), F = K(() => {
    y == null || y(), p(o.defaultColumnKeyMap);
  }, []), h = j(() => {
    var l, n;
    const s = [];
    return (l = o == null ? void 0 : o.columns) != null && l.length && ((n = o == null ? void 0 : o.columns) == null || n.map(({ key: m, dataIndex: a, ...r }) => {
      const f = A(
        m || a,
        [m || a].filter(Boolean).join("-")
      ), d = i[f || "null"];
      return (d == null ? void 0 : d.show) !== !1 && s.push({
        key: f,
        ...T(r, ["className"]),
        selectable: !1,
        disabled: (d == null ? void 0 : d.disable) === !0
      }), d;
    })), s.sort(_(i));
  }, [i, o == null ? void 0 : o.columns]), k = K(
    (s) => u == null ? void 0 : u.findIndex((l) => l === s),
    [u]
  ), S = j(
    () => x ? k(x) : -1,
    [x, k]
  ), M = j(() => {
    const s = [], l = /* @__PURE__ */ new Map();
    return { list: ((m, a) => m.map(({ key: r, dataIndex: f, children: d, ...I }) => {
      var E;
      const N = A(
        r || f,
        [a == null ? void 0 : a.columnKey, I.index].filter(Boolean).join("-")
      ), c = i[N || "null"] || { show: !0 };
      (c == null ? void 0 : c.show) !== !1 && !d && s.push(N);
      const g = {
        key: N,
        ...T(I, ["className"]),
        selectable: !1,
        disabled: c.disable === !0,
        disableCheckbox: typeof c.disable == "boolean" ? c == null ? void 0 : c.disable : (E = c == null ? void 0 : c.disable) == null ? void 0 : E.checkbox,
        isLeaf: a ? !0 : void 0
      };
      return l.set(r, g), g;
    }))(o == null ? void 0 : o.columns), keys: s, map: l };
  }, [i, o == null ? void 0 : o.columns]), L = (s, l) => {
    const n = { ...i };
    ((a) => {
      const r = { ...n[a] };
      r.show = !s, n[a] = r;
    })(l.key), p({ ...n });
  }, W = (s, l) => {
    const n = { ...i }, m = te(u, s, l);
    m.forEach((a, r) => {
      n[a] = { ...n[a] || {}, order: r };
    }), p(n), z(m);
  }, q = j(() => {
    var s, l;
    return x ? ((l = (s = o == null ? void 0 : o.columns) == null ? void 0 : s.find((n) => n.key === x)) == null ? void 0 : l.title) ?? "" : "";
  }, [o == null ? void 0 : o.columns, x, i, u]), G = () => {
    V({ ...i }), v.resolve({ ...i }), v.hide();
  }, D = () => {
    p({ ...R }), C.onCancel();
  };
  return /* @__PURE__ */ e.jsxs(
    Q,
    {
      className: "tableColumnSettingModal",
      title: "自定义列",
      ...C,
      width: 600,
      onCancel: D,
      footer: /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
        /* @__PURE__ */ e.jsx(
          O,
          {
            type: "primary",
            icon: /* @__PURE__ */ e.jsx(ie, {}),
            onClick: G,
            children: "保存"
          }
        ),
        /* @__PURE__ */ e.jsx(O, { onClick: D, children: "取消" })
      ] }),
      children: [
        /* @__PURE__ */ e.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
        /* @__PURE__ */ e.jsxs("div", { className: t.container, children: [
          /* @__PURE__ */ e.jsxs("div", { className: t.block, children: [
            /* @__PURE__ */ e.jsxs("div", { className: t.header, children: [
              /* @__PURE__ */ e.jsx("div", { className: t.title, children: "可用列" }),
              /* @__PURE__ */ e.jsx("div", {})
            ] }),
            /* @__PURE__ */ e.jsx("div", { className: t.body, children: /* @__PURE__ */ e.jsx("ul", { className: t.content, children: (w = M.list) == null ? void 0 : w.map((s) => {
              const l = M.keys.includes(s.key);
              return /* @__PURE__ */ e.jsxs(
                "li",
                {
                  className: B(t.item, {
                    [t.checked]: !l
                  }),
                  onClick: () => !s.disabled && L(l, s),
                  children: [
                    /* @__PURE__ */ e.jsx(U, { checked: l, disabled: s.disabled }),
                    /* @__PURE__ */ e.jsx("span", { className: t["content-item-text"], children: s.title })
                  ]
                },
                s.key
              );
            }) }) })
          ] }),
          /* @__PURE__ */ e.jsxs("div", { className: t.block, children: [
            /* @__PURE__ */ e.jsxs("div", { className: t.header, children: [
              /* @__PURE__ */ e.jsx("div", { className: t.title, children: "选定的列" }),
              /* @__PURE__ */ e.jsxs("div", { className: t.reset, onClick: F, children: [
                /* @__PURE__ */ e.jsx("div", { children: "重置  " }),
                /* @__PURE__ */ e.jsx(re, {})
              ] })
            ] }),
            /* @__PURE__ */ e.jsx("div", { className: t.body, children: /* @__PURE__ */ e.jsxs(
              $,
              {
                modifiers: [ae, ce],
                onDragStart: (s) => {
                  const { active: l } = s;
                  l && b(l == null ? void 0 : l.id);
                },
                onDragCancel: () => b(null),
                onDragEnd: (s) => {
                  b(null);
                  const { over: l } = s;
                  if (l) {
                    const n = k(l.id);
                    S !== n && W(S, n);
                  }
                },
                children: [
                  /* @__PURE__ */ e.jsx(
                    le,
                    {
                      items: h == null ? void 0 : h.map((s) => s.key),
                      strategy: oe,
                      children: /* @__PURE__ */ e.jsx("ul", { className: t.content, style: { background: "#fff" }, children: h == null ? void 0 : h.map((s) => /* @__PURE__ */ e.jsx(ne, { item: s }, s.key)) })
                    }
                  ),
                  /* @__PURE__ */ e.jsx(ee, { adjustScale: !1, dropAnimation: me, children: x ? /* @__PURE__ */ e.jsxs("li", { className: B(t.moveItem), children: [
                    /* @__PURE__ */ e.jsx(de, { className: t.dragIcon }),
                    /* @__PURE__ */ e.jsx("span", { className: t["moveItem-text"], children: q })
                  ] }) : null })
                ]
              }
            ) })
          ] })
        ] })
      ]
    }
  );
});
export {
  Ee as default
};
